// best
function prop(obj, key) {
    return obj[key];
}
function effectParser(effectFields) {
    let linkages = [];
    Object.keys(effectFields).forEach((target) => {
        let exp = prop(effectFields, target);
        let deps = [];
        // 依赖提取
        exp.replace(/\$Context\.(\S*)/gim, (m, name) => {
            if (!!name) {
                deps.push(name.split('.')[0]);
            }
            return m;
        });
        if (deps.length > 0) {
            linkages.push({
                exp,
                deps,
                target: target,
            });
        }
    });
    return linkages;
}
function getComponentName(id) {
    return id.toString().split('$')[0];
}
function getComponent(componentId, structure, cData, componentDetail) {
    let name = getComponentName(componentId);
    let childrens = structure[componentId] || [];
    let fieldData = (cData[componentId] || { fields: {} });
    let commonData = componentDetail ? componentDetail[name] : {};
    let { effect, fields = {}, effectFields, scriptFields } = fieldData;
    let { id: cid, status, resource, type, ..._componentData } = fields;
    let component = {
        id: componentId,
        n: name,
        d: Object.assign({}, { ...commonData }, _componentData),
        childrens: childrens.map((c) => getComponent(c, structure, cData, componentDetail)),
    };
    if (effectFields) {
        component.l = effectParser(effectFields);
    }
    if (scriptFields) {
        component.s = { ...scriptFields };
    }
    if (effect && effect.enble) {
        component.e = {
            uid: componentId,
            effects: effect.handles,
        };
    }
    return component;
}
function OBS_DataParser(schema) {
    let { hierarchy, data: cData } = schema;
    let { root, structure, componentDetail } = hierarchy;
    return [
        getComponent(root, structure, cData, componentDetail),
    ];
}

export default OBS_DataParser;
//# sourceMappingURL=index.esm.js.map
