(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('tslib')) :
    typeof define === 'function' && define.amd ? define(['tslib'], factory) :
    (global = global || self, global.ObsParser = factory(global.tslib));
}(this, function (tslib) { 'use strict';

    // best
    function prop(obj, key) {
        return obj[key];
    }
    function effectParser(effectFields) {
        var linkages = [];
        Object.keys(effectFields).forEach(function (target) {
            var exp = prop(effectFields, target);
            var deps = [];
            // 依赖提取
            exp.replace(/\$Context\.(\S*)/gim, function (m, name) {
                if (!!name) {
                    deps.push(name.split('.')[0]);
                }
                return m;
            });
            if (deps.length > 0) {
                linkages.push({
                    exp: exp,
                    deps: deps,
                    target: target,
                });
            }
        });
        return linkages;
    }
    function getComponentName(id) {
        return id.toString().split('$')[0];
    }
    function getComponent(componentId, structure, cData, componentDetail) {
        var name = getComponentName(componentId);
        var childrens = structure[componentId] || [];
        var fieldData = (cData[componentId] || { fields: {} });
        var commonData = componentDetail ? componentDetail[name] : {};
        var effect = fieldData.effect, _a = fieldData.fields, fields = _a === void 0 ? {} : _a, effectFields = fieldData.effectFields, scriptFields = fieldData.scriptFields;
        var cid = fields.id, status = fields.status, resource = fields.resource, type = fields.type, _componentData = tslib.__rest(fields, ["id", "status", "resource", "type"]);
        var component = {
            id: componentId,
            n: name,
            d: Object.assign({}, tslib.__assign({}, commonData), _componentData),
            childrens: childrens.map(function (c) {
                return getComponent(c, structure, cData, componentDetail);
            }),
        };
        if (effectFields) {
            component.l = effectParser(effectFields);
        }
        if (scriptFields) {
            component.s = tslib.__assign({}, scriptFields);
        }
        if (effect && effect.enble) {
            component.e = {
                uid: componentId,
                effects: effect.handles,
            };
        }
        return component;
    }
    function OBS_DataParser(schema) {
        var hierarchy = schema.hierarchy, cData = schema.data;
        var root = hierarchy.root, structure = hierarchy.structure, componentDetail = hierarchy.componentDetail;
        return [
            getComponent(root, structure, cData, componentDetail),
        ];
    }

    return OBS_DataParser;

}));
//# sourceMappingURL=index.umd.js.map
